=== extern/Base64/CMakeLists.txt ===
add_library(Base64 INTERFACE)
target_include_directories(Base64 INTERFACE .)
