=== debian/changelog ===
openmw (0.47.0-1ubuntu1) jammy; urgency=medium

  * Cherry-pick upstream commit to fix build with glibc 2.34

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 14 Apr 2022 08:48:39 +0000

openmw (0.47.0-1) unstable; urgency=low

  [ Bret Curtis ]
  * Upstream release: OpenMW-0.47.0
  * Add fix for compiling on m68k and sh4
  * Add dep on recastnavigation
  * Fixes ftbfs with GCC-11 (Closes: #984275)

  [ Tobias Frost ]
  * wrap-and-sort on d/control to better maintain dependencies.
  * Add B-D on liblz4-dev and librecast-dev (currently in NEW)
  * Set CMake option to use the packaged librecast in d/rules.
  * Fix d/watch.

  [ Pino Toscano ]
  * Move /usr/share/metainfo/openmw.appdata.xml from openmw-data to
    openmw-launcher, together with the desktop file & application it refers to
    - add proper breaks/replaces

 -- Bret Curtis <psi29a@gmail.com>  Sun, 17 Oct 2021 08:15:09 +0200
